package net.minecraft.src;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import net.minecraft.client.Minecraft;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

public class GuiIngame extends Gui {
	private static RenderItem itemRenderer = new RenderItem();
	private List chatMessageList = new ArrayList();
	private Random rand = new Random();
	private Minecraft mc;
	public String field_933_a = null;
	private int updateCounter = 0;
	private String recordPlaying = "";
	private int recordPlayingUpFor = 0;
	private boolean field_22065_l = false;
	public float field_6446_b;
	float prevVignetteBrightness = 1.0F;

	public GuiIngame(Minecraft minecraft1) {
		this.mc = minecraft1;
	}

	public void renderGameOverlay(float f1, boolean z2, int i3, int i4) {
		ScaledResolution scaledResolution5 = new ScaledResolution(this.mc.displayWidth, this.mc.displayHeight);
		int i6 = scaledResolution5.getScaledWidth();
		int i7 = scaledResolution5.getScaledHeight();
		FontRenderer fontRenderer8 = this.mc.fontRenderer;
		this.mc.entityRenderer.func_905_b();
		GL11.glEnable(GL11.GL_BLEND);
		if(Minecraft.func_22001_u()) {
			this.renderVignette(this.mc.thePlayer.getEntityBrightness(f1), i6, i7);
		}

		ItemStack itemStack9 = this.mc.thePlayer.inventory.armorItemInSlot(3);
		if(!this.mc.gameSettings.thirdPersonView && itemStack9 != null && itemStack9.itemID == Block.pumpkin.blockID) {
			this.renderPumpkinBlur(i6, i7);
		}

		float f10 = this.mc.thePlayer.prevTimeInPortal + (this.mc.thePlayer.timeInPortal - this.mc.thePlayer.prevTimeInPortal) * f1;
		if(f10 > 0.0F) {
			this.renderPortalOverlay(f10, i6, i7);
		}

		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("/gui/gui.png"));
		InventoryPlayer inventoryPlayer11 = this.mc.thePlayer.inventory;
		this.zLevel = -90.0F;
		this.drawTexturedModalRect(i6 / 2 - 91, i7 - 22, 0, 0, 182, 22);
		this.drawTexturedModalRect(i6 / 2 - 91 - 1 + inventoryPlayer11.currentItem * 20, i7 - 22 - 1, 0, 22, 24, 22);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("/gui/icons.png"));
		GL11.glEnable(GL11.GL_BLEND);
		GL11.glBlendFunc(GL11.GL_ONE_MINUS_DST_COLOR, GL11.GL_ONE_MINUS_SRC_COLOR);
		this.drawTexturedModalRect(i6 / 2 - 7, i7 / 2 - 7, 0, 0, 16, 16);
		GL11.glDisable(GL11.GL_BLEND);
		boolean z12 = this.mc.thePlayer.field_9306_bj / 3 % 2 == 1;
		if(this.mc.thePlayer.field_9306_bj < 10) {
			z12 = false;
		}

		int i13 = this.mc.thePlayer.health;
		int i14 = this.mc.thePlayer.prevHealth;
		this.rand.setSeed((long)(this.updateCounter * 312871));
		int i15;
		int i16;
		int i17;
		byte b19;
		if(this.mc.playerController.shouldDrawHUD()) {
			i15 = this.mc.thePlayer.getPlayerArmorValue();

			int i18;
			for(i16 = 0; i16 < 10; ++i16) {
				i17 = i7 - 32;
				if(i15 > 0) {
					i18 = i6 / 2 + 91 - i16 * 8 - 9;
					if(i16 * 2 + 1 < i15) {
						this.drawTexturedModalRect(i18, i17, 34, 9, 9, 9);
					}

					if(i16 * 2 + 1 == i15) {
						this.drawTexturedModalRect(i18, i17, 25, 9, 9, 9);
					}

					if(i16 * 2 + 1 > i15) {
						this.drawTexturedModalRect(i18, i17, 16, 9, 9, 9);
					}
				}

				b19 = 0;
				if(z12) {
					b19 = 1;
				}

				int i20 = i6 / 2 - 91 + i16 * 8;
				if(i13 <= 4) {
					i17 += this.rand.nextInt(2);
				}

				this.drawTexturedModalRect(i20, i17, 16 + b19 * 9, 0, 9, 9);
				if(z12) {
					if(i16 * 2 + 1 < i14) {
						this.drawTexturedModalRect(i20, i17, 70, 0, 9, 9);
					}

					if(i16 * 2 + 1 == i14) {
						this.drawTexturedModalRect(i20, i17, 79, 0, 9, 9);
					}
				}

				if(i16 * 2 + 1 < i13) {
					this.drawTexturedModalRect(i20, i17, 52, 0, 9, 9);
				}

				if(i16 * 2 + 1 == i13) {
					this.drawTexturedModalRect(i20, i17, 61, 0, 9, 9);
				}
			}

			if(this.mc.thePlayer.isInsideOfMaterial(Material.water)) {
				i16 = (int)Math.ceil((double)(this.mc.thePlayer.air - 2) * 10.0D / 300.0D);
				i17 = (int)Math.ceil((double)this.mc.thePlayer.air * 10.0D / 300.0D) - i16;

				for(i18 = 0; i18 < i16 + i17; ++i18) {
					if(i18 < i16) {
						this.drawTexturedModalRect(i6 / 2 - 91 + i18 * 8, i7 - 32 - 9, 16, 18, 9, 9);
					} else {
						this.drawTexturedModalRect(i6 / 2 - 91 + i18 * 8, i7 - 32 - 9, 25, 18, 9, 9);
					}
				}
			}
		}

		GL11.glDisable(GL11.GL_BLEND);
		GL11.glEnable(GL12.GL_RESCALE_NORMAL);
		GL11.glPushMatrix();
		GL11.glRotatef(180.0F, 1.0F, 0.0F, 0.0F);
		RenderHelper.enableStandardItemLighting();
		GL11.glPopMatrix();

		for(i15 = 0; i15 < 9; ++i15) {
			i16 = i6 / 2 - 90 + i15 * 20 + 2;
			i17 = i7 - 16 - 3;
			this.renderInventorySlot(i15, i16, i17, f1);
		}

		RenderHelper.disableStandardItemLighting();
		GL11.glDisable(GL12.GL_RESCALE_NORMAL);
		if(this.mc.thePlayer.func_22060_M() > 0) {
			GL11.glDisable(GL11.GL_DEPTH_TEST);
			GL11.glDisable(GL11.GL_ALPHA_TEST);
			i15 = this.mc.thePlayer.func_22060_M();
			float f32 = (float)i15 / 100.0F;
			if(f32 > 1.0F) {
				f32 = 1.0F - (float)(i15 - 100) / 10.0F;
			}

			i17 = (int)(220.0F * f32) << 24 | 1052704;
			this.drawRect(0, 0, i6, i7, i17);
			GL11.glEnable(GL11.GL_ALPHA_TEST);
			GL11.glEnable(GL11.GL_DEPTH_TEST);
		}

		String string34;
		if(this.mc.gameSettings.showDebugInfo) {
			fontRenderer8.drawStringWithShadow("Minecraft ", 2, 2, 10375468);
			fontRenderer8.drawStringWithShadow("Beta 1.3_01", 2 + fontRenderer8.getStringWidth("Minecraft "), 2, 43008);
			fontRenderer8.drawStringWithShadow(" (" + this.mc.debug + ")", 2 + fontRenderer8.getStringWidth("Minecraft Beta 1.3_01"), 2, 16579668);
			fontRenderer8.drawStringWithShadow(this.mc.func_6241_m(), 2, 12, 0xFFFFFF);
			fontRenderer8.drawStringWithShadow(this.mc.func_6262_n(), 2, 22, 0xFFFFFF);
			fontRenderer8.drawStringWithShadow(this.mc.func_6245_o(), 2, 32, 0xFFFFFF);
			fontRenderer8.drawStringWithShadow(this.mc.func_21002_o(), 2, 152, 0xFFFFFF);
			long j33 = Runtime.getRuntime().maxMemory();
			long j21 = Runtime.getRuntime().totalMemory();
			long j23 = Runtime.getRuntime().freeMemory();
			long j25 = j21 - j23;
			string34 = "Used memory: " + j25 * 100L / j33 + "% (" + j25 / 1024L / 1024L + "MB) of " + j33 / 1024L / 1024L + "MB";
			this.drawString(fontRenderer8, string34, i6 - fontRenderer8.getStringWidth(string34) - 2, 2, 14737632);
			string34 = "Allocated memory: " + j21 * 100L / j33 + "% (" + j21 / 1024L / 1024L + "MB)";
			this.drawString(fontRenderer8, string34, i6 - fontRenderer8.getStringWidth(string34) - 2, 12, 14737632);
			int i27 = MathHelper.floor_double(this.mc.thePlayer.posX);
			int i28 = MathHelper.floor_double(this.mc.thePlayer.posY);
			int i29 = MathHelper.floor_double(this.mc.thePlayer.posZ);
			fontRenderer8.drawStringWithShadow("X", 2, 102, 16536660);
			fontRenderer8.drawStringWithShadow("Y", 2 + fontRenderer8.getStringWidth("X"), 102, 5569620);
			fontRenderer8.drawStringWithShadow("Z", 2 + fontRenderer8.getStringWidth("XY"), 102, 5569788);
			fontRenderer8.drawStringWithShadow(String.format(": %.4f ", new Object[]{this.mc.thePlayer.posX}), 2 + fontRenderer8.getStringWidth("XYZ"), 102, 16536660);
			fontRenderer8.drawStringWithShadow(String.format(" %.4f ", new Object[]{this.mc.thePlayer.posY}), 2 + fontRenderer8.getStringWidth("XYZ" + String.format(": %.4f ", new Object[]{this.mc.thePlayer.posX})), 102, 5569620);
			fontRenderer8.drawStringWithShadow(String.format(" %.4f", new Object[]{this.mc.thePlayer.posZ}), 2 + fontRenderer8.getStringWidth("XYZ" + String.format(": %.4f ", new Object[]{this.mc.thePlayer.posX}) + String.format(" %.4f ", new Object[]{this.mc.thePlayer.posY})), 102, 5569788);
			fontRenderer8.drawStringWithShadow("SPAWN ", 2, 112, 43260);
			fontRenderer8.drawStringWithShadow("X", 2 + fontRenderer8.getStringWidth("SPAWN "), 112, 16536660);
			fontRenderer8.drawStringWithShadow("Y", 2 + fontRenderer8.getStringWidth("SPAWN X"), 112, 5569620);
			fontRenderer8.drawStringWithShadow("Z", 2 + fontRenderer8.getStringWidth("SPAWN XY"), 112, 5569788);
			fontRenderer8.drawStringWithShadow(": " + this.mc.theWorld.worldinfo.spawnX, 2 + fontRenderer8.getStringWidth("SPAWN XYZ"), 112, 16536660);
			fontRenderer8.drawStringWithShadow(" " + this.mc.theWorld.worldinfo.spawnY, 2 + fontRenderer8.getStringWidth("SPAWN XYZ: " + this.mc.theWorld.worldinfo.spawnX), 112, 5569620);
			fontRenderer8.drawStringWithShadow(" " + this.mc.theWorld.worldinfo.spawnZ, 2 + fontRenderer8.getStringWidth("SPAWN XYZ: " + this.mc.theWorld.worldinfo.spawnX + " " + this.mc.theWorld.worldinfo.spawnY), 112, 5569788);
			int i30 = MathHelper.floor_double((double)(this.mc.thePlayer.rotationYaw * 4.0F / 360.0F) + 0.5D) & 3;
			this.drawString(fontRenderer8, "Direction: " + i30 + " (" + Direction.directions[i30] + ") / " + MathHelper.wrapAngleTo180_float(this.mc.thePlayer.rotationYaw), 2, 122, 0xFFFFFF);
			if(this.mc.theWorld != null && this.mc.theWorld.blockExists(i27, i28, i29)) {
				Chunk chunk31 = this.mc.theWorld.getChunkFromBlockCoords(i27, i29);
				fontRenderer8.drawStringWithShadow("Block Light: ", 2, 132, 43260);
				fontRenderer8.drawStringWithShadow("" + chunk31.getSavedLightValue(EnumSkyBlock.Block, i27 & 15, i28, i29 & 15), 2 + fontRenderer8.getStringWidth("Block Light: "), 132, 5569620);
				fontRenderer8.drawStringWithShadow(", Sky Light: ", 2 + fontRenderer8.getStringWidth("Block Light: " + chunk31.getSavedLightValue(EnumSkyBlock.Block, i27 & 15, i28, i29 & 15)), 132, 43260);
				fontRenderer8.drawStringWithShadow("" + chunk31.getSavedLightValue(EnumSkyBlock.Sky, i27 & 15, i28, i29 & 15), 2 + fontRenderer8.getStringWidth("Block Light: " + chunk31.getSavedLightValue(EnumSkyBlock.Block, i27 & 15, i28, i29 & 15) + " Sky Light: "), 132, 5569620);
				fontRenderer8.drawStringWithShadow(", Combined Light: ", 2 + fontRenderer8.getStringWidth("Block Light: " + chunk31.getSavedLightValue(EnumSkyBlock.Block, i27 & 15, i28, i29 & 15) + " Sky Light: " + chunk31.getSavedLightValue(EnumSkyBlock.Sky, i27 & 15, i28, i29 & 15)), 132, 43260);
				fontRenderer8.drawStringWithShadow("" + chunk31.getBlockLightValue(i27 & 15, i28, i29 & 15, 0), 2 + fontRenderer8.getStringWidth("Block Light: " + chunk31.getSavedLightValue(EnumSkyBlock.Block, i27 & 15, i28, i29 & 15) + " Sky Light: " + chunk31.getSavedLightValue(EnumSkyBlock.Sky, i27 & 15, i28, i29 & 15) + " Combined Light: "), 132, 5569620);
			}

			fontRenderer8.drawStringWithShadow("On Ground:", 2, 142, 43260);
			fontRenderer8.drawStringWithShadow(String.format(" %b", new Object[]{this.mc.thePlayer.onGround}), 2 + fontRenderer8.getStringWidth("On Ground:"), 142, 5569620);
			fontRenderer8.drawStringWithShadow(", ", 2 + fontRenderer8.getStringWidth("On Ground:" + String.format(" %b", new Object[]{this.mc.thePlayer.onGround})), 142, 0xFFFFFF);
			fontRenderer8.drawStringWithShadow("Highest Block:", 2 + fontRenderer8.getStringWidth("On Ground:" + String.format(" %b", new Object[]{this.mc.thePlayer.onGround}) + ", "), 142, 43260);
			fontRenderer8.drawStringWithShadow(String.format(" %d", new Object[]{this.mc.theWorld.getHeightValue(i27, i29)}), 2 + fontRenderer8.getStringWidth("On Ground:" + String.format(" %b", new Object[]{this.mc.thePlayer.onGround}) + ", Highest Block:"), 142, 5569620);
		} else {
			fontRenderer8.drawStringWithShadow("Minecraft Beta 1.3_01", 2, 2, 0xFFFFFF);
		}

		if(this.recordPlayingUpFor > 0) {
			float f35 = (float)this.recordPlayingUpFor - f1;
			i16 = (int)(f35 * 256.0F / 20.0F);
			if(i16 > 255) {
				i16 = 255;
			}

			if(i16 > 0) {
				GL11.glPushMatrix();
				GL11.glTranslatef((float)(i6 / 2), (float)(i7 - 48), 0.0F);
				GL11.glEnable(GL11.GL_BLEND);
				GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
				i17 = 0xFFFFFF;
				if(this.field_22065_l) {
					i17 = Color.HSBtoRGB(f35 / 50.0F, 0.7F, 0.6F) & 0xFFFFFF;
				}

				fontRenderer8.drawString(this.recordPlaying, -fontRenderer8.getStringWidth(this.recordPlaying) / 2, -4, i17 + (i16 << 24));
				GL11.glDisable(GL11.GL_BLEND);
				GL11.glPopMatrix();
			}
		}

		b19 = 10;
		boolean z36 = false;
		if(this.mc.currentScreen instanceof GuiChat) {
			b19 = 20;
			z36 = true;
		}

		GL11.glEnable(GL11.GL_BLEND);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glDisable(GL11.GL_ALPHA_TEST);
		GL11.glPushMatrix();
		GL11.glTranslatef(0.0F, (float)(i7 - 48), 0.0F);

		for(i17 = 0; i17 < this.chatMessageList.size() && i17 < b19; ++i17) {
			if(((ChatLine)this.chatMessageList.get(i17)).updateCounter < 200 || z36) {
				double d37 = (double)((ChatLine)this.chatMessageList.get(i17)).updateCounter / 200.0D;
				d37 = 1.0D - d37;
				d37 *= 10.0D;
				if(d37 < 0.0D) {
					d37 = 0.0D;
				}

				if(d37 > 1.0D) {
					d37 = 1.0D;
				}

				d37 *= d37;
				int i38 = (int)(255.0D * d37);
				if(z36) {
					i38 = 255;
				}

				if(i38 > 0) {
					byte b24 = 2;
					int i39 = -i17 * 9;
					string34 = ((ChatLine)this.chatMessageList.get(i17)).message;
					this.drawRect(b24, i39 - 1, b24 + 320, i39 + 8, i38 / 2 << 24);
					GL11.glEnable(GL11.GL_BLEND);
					fontRenderer8.drawStringWithShadow(string34, b24, i39, 0xFFFFFF + (i38 << 24));
				}
			}
		}

		GL11.glPopMatrix();
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glDisable(GL11.GL_BLEND);
	}

	private void renderPumpkinBlur(int i1, int i2) {
		GL11.glDisable(GL11.GL_DEPTH_TEST);
		GL11.glDepthMask(false);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		GL11.glDisable(GL11.GL_ALPHA_TEST);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("%blur%/misc/pumpkinblur.png"));
		Tessellator tessellator3 = Tessellator.instance;
		tessellator3.startDrawingQuads();
		tessellator3.addVertexWithUV(0.0D, (double)i2, -90.0D, 0.0D, 1.0D);
		tessellator3.addVertexWithUV((double)i1, (double)i2, -90.0D, 1.0D, 1.0D);
		tessellator3.addVertexWithUV((double)i1, 0.0D, -90.0D, 1.0D, 0.0D);
		tessellator3.addVertexWithUV(0.0D, 0.0D, -90.0D, 0.0D, 0.0D);
		tessellator3.draw();
		GL11.glDepthMask(true);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
	}

	private void renderVignette(float f1, int i2, int i3) {
		f1 = 1.0F - f1;
		if(f1 < 0.0F) {
			f1 = 0.0F;
		}

		if(f1 > 1.0F) {
			f1 = 1.0F;
		}

		this.prevVignetteBrightness = (float)((double)this.prevVignetteBrightness + (double)(f1 - this.prevVignetteBrightness) * 0.01D);
		GL11.glDisable(GL11.GL_DEPTH_TEST);
		GL11.glDepthMask(false);
		GL11.glBlendFunc(GL11.GL_ZERO, GL11.GL_ONE_MINUS_SRC_COLOR);
		GL11.glColor4f(this.prevVignetteBrightness, this.prevVignetteBrightness, this.prevVignetteBrightness, 1.0F);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("%blur%/misc/vignette.png"));
		Tessellator tessellator4 = Tessellator.instance;
		tessellator4.startDrawingQuads();
		tessellator4.addVertexWithUV(0.0D, (double)i3, -90.0D, 0.0D, 1.0D);
		tessellator4.addVertexWithUV((double)i2, (double)i3, -90.0D, 1.0D, 1.0D);
		tessellator4.addVertexWithUV((double)i2, 0.0D, -90.0D, 1.0D, 0.0D);
		tessellator4.addVertexWithUV(0.0D, 0.0D, -90.0D, 0.0D, 0.0D);
		tessellator4.draw();
		GL11.glDepthMask(true);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
	}

	private void renderPortalOverlay(float f1, int i2, int i3) {
		f1 *= f1;
		f1 *= f1;
		f1 = f1 * 0.8F + 0.2F;
		GL11.glDisable(GL11.GL_ALPHA_TEST);
		GL11.glDisable(GL11.GL_DEPTH_TEST);
		GL11.glDepthMask(false);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, f1);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("/terrain.png"));
		float f4 = (float)(Block.portal.blockIndexInTexture % 16) / 16.0F;
		float f5 = (float)(Block.portal.blockIndexInTexture / 16) / 16.0F;
		float f6 = (float)(Block.portal.blockIndexInTexture % 16 + 1) / 16.0F;
		float f7 = (float)(Block.portal.blockIndexInTexture / 16 + 1) / 16.0F;
		Tessellator tessellator8 = Tessellator.instance;
		tessellator8.startDrawingQuads();
		tessellator8.addVertexWithUV(0.0D, (double)i3, -90.0D, (double)f4, (double)f7);
		tessellator8.addVertexWithUV((double)i2, (double)i3, -90.0D, (double)f6, (double)f7);
		tessellator8.addVertexWithUV((double)i2, 0.0D, -90.0D, (double)f6, (double)f5);
		tessellator8.addVertexWithUV(0.0D, 0.0D, -90.0D, (double)f4, (double)f5);
		tessellator8.draw();
		GL11.glDepthMask(true);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
	}

	private void renderInventorySlot(int i1, int i2, int i3, float f4) {
		ItemStack itemStack5 = this.mc.thePlayer.inventory.mainInventory[i1];
		if(itemStack5 != null) {
			float f6 = (float)itemStack5.animationsToGo - f4;
			if(f6 > 0.0F) {
				GL11.glPushMatrix();
				float f7 = 1.0F + f6 / 5.0F;
				GL11.glTranslatef((float)(i2 + 8), (float)(i3 + 12), 0.0F);
				GL11.glScalef(1.0F / f7, (f7 + 1.0F) / 2.0F, 1.0F);
				GL11.glTranslatef((float)(-(i2 + 8)), (float)(-(i3 + 12)), 0.0F);
			}

			itemRenderer.renderItemIntoGUI(this.mc.fontRenderer, this.mc.renderEngine, itemStack5, i2, i3);
			if(f6 > 0.0F) {
				GL11.glPopMatrix();
			}

			itemRenderer.renderItemOverlayIntoGUI(this.mc.fontRenderer, this.mc.renderEngine, itemStack5, i2, i3);
		}

	}

	public void updateTick() {
		if(this.recordPlayingUpFor > 0) {
			--this.recordPlayingUpFor;
		}

		++this.updateCounter;

		for(int i1 = 0; i1 < this.chatMessageList.size(); ++i1) {
			++((ChatLine)this.chatMessageList.get(i1)).updateCounter;
		}

	}

	public void addChatMessage(String string1) {
		while(this.mc.fontRenderer.getStringWidth(string1) > 320) {
			int i2;
			for(i2 = 1; i2 < string1.length() && this.mc.fontRenderer.getStringWidth(string1.substring(0, i2 + 1)) <= 320; ++i2) {
			}

			this.addChatMessage(string1.substring(0, i2));
			string1 = string1.substring(i2);
		}

		this.chatMessageList.add(0, new ChatLine(string1));

		while(this.chatMessageList.size() > 50) {
			this.chatMessageList.remove(this.chatMessageList.size() - 1);
		}

	}

	public void setRecordPlayingMessage(String string1) {
		this.recordPlaying = "Now playing: " + string1;
		this.recordPlayingUpFor = 60;
		this.field_22065_l = true;
	}

	public void func_22064_c(String string1) {
		StringTranslate stringTranslate2 = StringTranslate.getInstance();
		String string3 = stringTranslate2.translateKey(string1);
		this.addChatMessage(string3);
	}
}
